#define DIRECTINPUT_VERSION 0x0800
#include <dinput.h> 
#pragma comment(lib,"dinput8.lib") 
#pragma comment(lib,"dxguid.lib")

#define SafeRelease(x) if(x){x->Release(); x=NULL;}

LPDIRECTINPUT8 lpDI=NULL;
LPDIRECTINPUTDEVICE8 lpMouse=NULL;

HRESULT InitDInput(HINSTANCE hInstance,HWND hwnd) 
{
 	HRESULT hr=DirectInput8Create(hInstance, DIRECTINPUT_VERSION, 
			IID_IDirectInput8, (void**)&lpDI, NULL); 
	if(FAILED(hr)) return E_FAIL;

	// mouse
	hr=lpDI->CreateDevice(GUID_SysMouse, &lpMouse, NULL); 
	if(FAILED(hr)) return E_FAIL;
	hr=lpMouse->SetDataFormat(&c_dfDIMouse); 
	if(FAILED(hr)) return E_FAIL;  
	hr=lpMouse->SetCooperativeLevel(hwnd,DISCL_BACKGROUND | DISCL_NONEXCLUSIVE);   
	// changed from foreground seems not to need re-aquired 
	if(FAILED(hr)) return E_FAIL; 

	DIPROPDWORD dipdw;
    // the header
    dipdw.diph.dwSize       = sizeof(DIPROPDWORD);
    dipdw.diph.dwHeaderSize = sizeof(DIPROPHEADER);
    dipdw.diph.dwObj        = 0;
    dipdw.diph.dwHow        = DIPH_DEVICE; 
    // the data
    dipdw.dwData            = DIPROPAXISMODE_REL ;	

	lpMouse->SetProperty(DIPROP_AXISMODE,&dipdw.diph);
	hr=lpMouse->Acquire(); 
	if(FAILED(hr))return E_FAIL;

	return S_OK;
}

POINT ProcessInput() 
{ 
	DIMOUSESTATE dims;
	POINT point={-1,-1}; // error code 

	HRESULT hr=lpMouse->GetDeviceState(sizeof(dims),&dims);
	if(FAILED(hr)) return point;   

	point.x=dims.lX; point.y=dims.lY;
	return point;
}

void CleanupDInput()
{
	if(lpMouse) lpMouse->Unacquire();
	SafeRelease(lpMouse);
	SafeRelease(lpDI);
}