// note to group radio buttons, "group" first button in each group 

#include <windows.h>
#include "resource.h"
#include <d3d8.h>

char instructions[]="3D Pool\r\n\r\nHow to Play\r\n\r\nMove mouse to change view around table. \r\n'Z' +mouse up/down for zoom on cue ball. \r\n'S' +mouse up/down to swing the cue and hit cue ball. \r\nF1,F2,F3 resets to 15 ball, 9 ball or snooker game.\r\n'W' wireframe\r\n'C' change table cloth\r\n'B' change ball type in 15 ball game\r\n'T' change table \r\n'G' gravity flip\r\n'A' +mouse up/down slant cue \r\n'O' One hit wonder shot\r\n'F' fog\r\n'H' Ball Highlights\r\n'V' Widescreen\r\n'esc' quits";

void GetRegSettings();

extern UINT nAdapters;
extern int uAdapter,uMode,GameType,table;
extern BOOL quit,Desktop8Bit,Windowed;

extern struct _m{
 	char Description[MAX_DEVICE_IDENTIFIER_STRING];
	UINT nModes;
	D3DDISPLAYMODE DisplayMode; 
	D3DDISPLAYMODE *pModes;
}*pAdapterModes;

int FormatColBits(D3DFORMAT f)
{
	switch(f)
	{
	case D3DFMT_X1R5G5B5: return 16;
	case D3DFMT_R5G6B5: return 16;
	case D3DFMT_X8R8G8B8: return 32;
	case D3DFMT_A8R8G8B8: return 32;
	}
	return 0;
}

void FillEnum(HWND hDlg)
{
	char str[100];
	SendDlgItemMessage(hDlg,ADAP,CB_RESETCONTENT,0,0);
	SendDlgItemMessage(hDlg,MODES,CB_RESETCONTENT,0,0);

	for(UINT a=0;a<nAdapters;a++)
	{
		SendDlgItemMessage(hDlg,ADAP,CB_ADDSTRING,0,LPARAM(pAdapterModes[a].Description));
	}

	for(UINT m=0;m<pAdapterModes[uAdapter].nModes;m++)
	{
		wsprintf(str,"%d*%d,%dbit %dhz",pAdapterModes[uAdapter].pModes[m].Width,
			pAdapterModes[uAdapter].pModes[m].Height,
			FormatColBits(pAdapterModes[uAdapter].pModes[m].Format),
			pAdapterModes[uAdapter].pModes[m].RefreshRate);
		SendDlgItemMessage(hDlg,MODES,CB_ADDSTRING,0,LPARAM(LPSTR(str)) );
	}

	SendDlgItemMessage(hDlg,ADAP,CB_SETCURSEL,uAdapter,0);
	SendDlgItemMessage(hDlg,MODES,CB_SETCURSEL,uMode,0);	
}	

BOOL CALLBACK StartupDlgProc(HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam)
{
	switch(message)
	{
	case WM_INITDIALOG:
		GetRegSettings(); // get saved setting settings or set to 0,0,15,0,0 
		FillEnum(hDlg);
		SendDlgItemMessage(hDlg,ADAP,CB_SETCURSEL,uAdapter,0);
		SendDlgItemMessage(hDlg,MODES,CB_SETCURSEL,uMode,0);
		if(Windowed && Desktop8Bit==FALSE)  // if not 8bit desktop 
		{ 
			Windowed=TRUE; 
			EnableWindow(GetDlgItem(hDlg,ADAP),FALSE);
			EnableWindow(GetDlgItem(hDlg,MODES),FALSE);
			CheckRadioButton(hDlg,IDC_RADIO2,IDC_RADIO3,IDC_RADIO2); // set to Windowed current
		}
		else
		{
			Windowed=FALSE;
			CheckRadioButton(hDlg,IDC_RADIO2,IDC_RADIO3,IDC_RADIO3); // set to Fullscreen current
		}
		if(GameType==9)	 CheckRadioButton(hDlg,BALL9,SNOOKER,BALL9);  
		if(GameType==15) CheckRadioButton(hDlg,BALL9,SNOOKER,BALL15);  		
		if(GameType==21) CheckRadioButton(hDlg,BALL9,SNOOKER,SNOOKER);  

		if(table==0) CheckRadioButton(hDlg,TABLE8,TABLE8L,TABLE8);  
		if(table==1) CheckRadioButton(hDlg,TABLE8,TABLE8L,TABLE10);  		
		if(table==2) CheckRadioButton(hDlg,TABLE8,TABLE8L,TABLE8L);  
		return TRUE;
	case WM_COMMAND:
		switch(HIWORD(wParam))
		{
		case CBN_SELCHANGE: 
			if(LOWORD(wParam)==ADAP)
			{
			   uAdapter=SendDlgItemMessage(hDlg,ADAP,CB_GETCURSEL,0,0);
			   uMode=0; // safe to set to 0 
			   FillEnum(hDlg);
			   return 0;
			}

			if(LOWORD(wParam)==MODES)
			{
			   uMode=SendDlgItemMessage(hDlg,MODES,CB_GETCURSEL,0,0);
			   return 0;
			}
			break;
		case BN_CLICKED: 
			if(LOWORD(wParam)==IDC_RADIO2)
			{
				SendDlgItemMessage(hDlg,ADAP,CB_SETCURSEL,0,0);
				SendDlgItemMessage(hDlg,MODES,CB_SETCURSEL,0,0);
				EnableWindow(GetDlgItem(hDlg,ADAP),FALSE);
				EnableWindow(GetDlgItem(hDlg,MODES),FALSE);
			}
			if(LOWORD(wParam)==IDC_RADIO3)
			{
				SendDlgItemMessage(hDlg,ADAP,CB_SETCURSEL,uAdapter,0);
				SendDlgItemMessage(hDlg,MODES,CB_SETCURSEL,uMode,0);
				EnableWindow(GetDlgItem(hDlg,ADAP),TRUE);
				EnableWindow(GetDlgItem(hDlg,MODES),TRUE);
			}
			break;
		}
		switch(LOWORD(wParam))
		{
		case IDOK:
			if(BST_CHECKED==IsDlgButtonChecked(hDlg,IDC_RADIO2) )
				{ uAdapter=0; Windowed=TRUE; }  // ie can't move window, also may be 8 bit 
			if(BST_CHECKED==IsDlgButtonChecked(hDlg,IDC_RADIO3) )
				{ Windowed=FALSE; }
			if(BST_CHECKED==IsDlgButtonChecked(hDlg,BALL9) )
				{ GameType=9; }
			if(BST_CHECKED==IsDlgButtonChecked(hDlg,BALL15) )
				{ GameType=15; }
			if(BST_CHECKED==IsDlgButtonChecked(hDlg,SNOOKER) )
				{ GameType=21; }
			if(BST_CHECKED==IsDlgButtonChecked(hDlg,TABLE8) )
				{ table=0; }
			if(BST_CHECKED==IsDlgButtonChecked(hDlg,TABLE10) )
				{ table=1; }
			if(BST_CHECKED==IsDlgButtonChecked(hDlg,TABLE8L) )
				{ table=2; }
			EndDialog(hDlg,0);
			return TRUE;
		case IDCANCEL:			
			quit=TRUE;
			EndDialog(hDlg,0);
			return TRUE;
		case IDHELP:
			MessageBox(hDlg,instructions,"Instructions",MB_OK); // change to chm 
			return TRUE;
		}
		break;
	}
	return FALSE;
}
