#include <dmusicc.h>  
#include <dmusici.h>

IDirectMusicLoader8* pLoader=NULL;   
IDirectMusicPerformance8* pPerformance=NULL;
IDirectMusicSegment8* pSegmentClick=NULL; 
IDirectMusicSegment8* pSegmentStrike=NULL;
IDirectMusicSegment8* pSegmentPot=NULL;
IDirectMusicSegment8* pSegmentBounce=NULL;
BOOL DMActive=FALSE;

HRESULT InitLoadDMusic()  // can put .wav in to resources from /sounds folder 
{
	CoInitialize(NULL); 
	CoCreateInstance( CLSID_DirectMusicLoader, NULL, CLSCTX_INPROC, 
                      IID_IDirectMusicLoader8, (void**)&pLoader );
    CoCreateInstance( CLSID_DirectMusicPerformance, NULL, CLSCTX_INPROC, 
                      IID_IDirectMusicPerformance8, (void**)&pPerformance );
    pPerformance->InitAudio(NULL,NULL,NULL,
		DMUS_APATH_DYNAMIC_STEREO,64,DMUS_AUDIOF_ALL, NULL );

	DMUS_OBJECTDESC objDesc;

	HRSRC hFound=FindResource(NULL,"bounce.wav","WAVE");
	HGLOBAL hRes=LoadResource(NULL,hFound);
	if(NULL==hRes){	return E_FAIL; }

	objDesc.dwSize = sizeof(DMUS_OBJECTDESC);
    objDesc.guidClass = CLSID_DirectMusicSegment;
	objDesc.dwValidData = DMUS_OBJ_CLASS | DMUS_OBJ_MEMORY;
	objDesc.pbMemData = (BYTE *) LockResource(hRes);
	objDesc.llMemLength = SizeofResource(NULL, hFound);
 
	if(FAILED( pLoader->GetObject(&objDesc, IID_IDirectMusicSegment8, 
		(void**) &pSegmentBounce) )){ return E_FAIL; }
	pSegmentBounce->Download(pPerformance );
	
	hFound=FindResource(NULL,"strike.wav","WAVE");
	hRes=LoadResource(NULL,hFound);
	if(NULL==hRes){	return E_FAIL; }

	objDesc.pbMemData = (BYTE *) LockResource(hRes);
	objDesc.llMemLength = SizeofResource(NULL, hFound);
 
	if(FAILED( pLoader->GetObject(&objDesc, IID_IDirectMusicSegment8, 
		(void**) &pSegmentStrike) )){ return E_FAIL; }
	pSegmentStrike->Download(pPerformance );

	hFound=FindResource(NULL,"pot.wav","WAVE");
	hRes=LoadResource(NULL,hFound);
	if(NULL==hRes){	return E_FAIL; }

	objDesc.pbMemData = (BYTE *) LockResource(hRes);
	objDesc.llMemLength = SizeofResource(NULL, hFound);
 
	if(FAILED( pLoader->GetObject(&objDesc, IID_IDirectMusicSegment8, 
		(void**) &pSegmentPot) )){ return E_FAIL; }
	pSegmentPot->Download(pPerformance );

	hFound=FindResource(NULL,"click.wav","WAVE");
	hRes=LoadResource(NULL,hFound);
	if(NULL==hRes){	return E_FAIL; }

	objDesc.pbMemData = (BYTE *) LockResource(hRes);
	objDesc.llMemLength = SizeofResource(NULL, hFound);
 
	if(FAILED( pLoader->GetObject(&objDesc, IID_IDirectMusicSegment8, 
		(void**) &pSegmentClick) )){ return E_FAIL; }
	pSegmentClick->Download(pPerformance );

 	DMActive=TRUE; // ie all sounds loaded ok 
	return S_OK;
}

void PlayClick() { if(DMActive) pPerformance->PlaySegmentEx(pSegmentClick,NULL,NULL,0,0,NULL,NULL,NULL); }
void PlayPot()   { if(DMActive) pPerformance->PlaySegmentEx(pSegmentPot,NULL,NULL,0,0,NULL,NULL,NULL); }
void PlayStrike(){ if(DMActive) pPerformance->PlaySegmentEx(pSegmentStrike,NULL,NULL,0,0,NULL,NULL,NULL); }
void PlayBounce(){ if(DMActive) pPerformance->PlaySegmentEx(pSegmentBounce,NULL,NULL,0,0,NULL,NULL,NULL); }

void CleanupDMusic(void)
{
	if(DMActive) 
	{
		pPerformance->Stop(NULL,NULL,0,0);
		pPerformance->CloseDown();
	    pLoader->Release(); 
	    pPerformance->Release();
	    pSegmentClick->Release();
		pSegmentStrike->Release();
		pSegmentPot->Release();
		pSegmentBounce->Release();
	}
	CoUninitialize(); 
}