/*	DX8 3d pool 1.1 April,Dec 2003 Free 

	Balls typically 57mm diameter textured 0=white 
    table = 8' 2.24m*1.12m*0.8m 0,0,0 centre of table on floor ( NOT on table surface ) 

	't' table change   	'c' cloth change  	'b' change ball set 
	's' shoot 	'z' zoom 	'f' fps TODO 	'd' state of play TODO
	'w' wire frame 	'f1' new 15ball game	'f2' new 9ball game		'f3' new snooker game 
	'1' 1 player  todo	'2' 2 player  todo	'n' network player todo 

	double check all maths / seems to be funny at very low fps 
	bugs : initially balls don't collide ?   */

#include <d3dx8.h>   //load .x files 
#pragma comment(lib,"d3d8.lib")
#pragma comment(lib,"d3dx8.lib")
#include "resource.h"
#include "data.h"

HRESULT InitLoadDMusic(void);   // dmusic.cpp
void CleanupDMusic(void);
void PlayClick(void);
void PlayPot(void);
void PlayStrike(void);
void PlayBounce(void);

HRESULT InitDInput(HINSTANCE,HWND);   // dinput.cpp
void CleanupDInput(void);
POINT ProcessInput(void);

void SaveRegSettings(DWORD,DWORD,DWORD,DWORD,DWORD);

BOOL Windowed=FALSE; 
int uAdapter=0; int uMode=0;
int GameType=15; // 9,15,21 

void QPFTimer(void);  // timer.cpp
float GetElapsed(void);
float time_elapsed;
FLOAT Timer(D3DAPPTIMER);

BOOL CALLBACK StartupDlgProc(HWND,UINT,WPARAM,LPARAM); // dlg.cpp

#define SafeRelease(x) if(x){x->Release(); x=NULL;}

HRESULT LoadGeometry(void);

LPDIRECT3D8 lpD3D=NULL;
LPDIRECT3DDEVICE8 lpD3DDevice=NULL;
D3DDISPLAYMODE d3ddm;
D3DPRESENT_PARAMETERS d3dpp;
BOOL active=FALSE,ready=FALSE;   // add pause for menu 

float ballDiameter,ballRadius; // 57mm , 28.5mm 
float tableHeight; // ie 80cm 
float pocketRadius; // meters
float CueFromBall;  // distance from cue tip to cue ball surface 
float CueSpeed;   // m/s 
float cuemaxfromball; // ie 30cm from ball 
float cueminfromball; // ie 1 cm from ball triggers hit  
float viewDistFromCueBall; // 1.5m from cue ball view 
float cueViewMin,cueViewMax; // view from cue ball min,max meters ie 10cm 10m 
float RotY,rotY=0.0f; 
float EyeY,eyeY=0.0f; // eye level 1.8m up initially 
float minEyeY,maxEyeY; // min/max height to view ?? table height 
float CueBallFromCushon=1.0f;// used to keep cue from going into cushon
float coef_friction=0.7f;
float rot_factor=20.0f; 
float cueSlant=0.1f;
BOOL cueSlantAdjust=FALSE;
int nCPoints;
D3DXVECTOR3 cPoints[100];
BOOL shoot=FALSE;
BOOL zoom=FALSE;
BOOL gravup=FALSE;
BOOL fog=FALSE;
BOOL specular=TRUE;

HINSTANCE g_hInst;
RECT rect;

BOOL changeViewport=FALSE;
int hdtv=0;
float fov[]={1.0f,1.25f};
float aspect[]={1.25f,1.0f};
DWORD ambient[]={0x00707070,0x004040F0};

D3DXMATRIX world,view,proj;
D3DXVECTOR3 eye,at;   // eye/camera position and look at position ??? 
D3DXVECTOR3 nCue; // normalized direction of cue to ball[0] 
BOOL wireframe=FALSE; // rendering option 

int nTables=3; // load from file 
int table=0; // 0 is 2.4m 8ft 1 is 12ft snooker 2 is L 2.4 table 
int tableCloth[10][20]; // 10 tables upto 20 materials, i is cloth material 
LPDIRECT3DTEXTURE8 *lpTableClothTextures; // 6 cloths
int cloth=1;

struct _table{
	LPD3DXMESH lpMesh;
	D3DMATERIAL8 *lpMaterials;
	LPDIRECT3DTEXTURE8 *lpTextures;
	DWORD nMaterials;
} *lpTable;

LPD3DXMESH lpScene=NULL;
D3DMATERIAL8 *lpSceneMaterials=NULL;
LPDIRECT3DTEXTURE8 *lpSceneTextures=NULL;
DWORD nSceneMaterials=0L;

LPD3DXMESH lpShadow=NULL;       // change to proper shadows 
D3DMATERIAL8 *lpShadowMaterials=NULL;
LPDIRECT3DTEXTURE8 *lpShadowTextures=NULL;
DWORD nShadowMaterials=0L;

struct _cue{
	LPD3DXMESH lpMesh;
	D3DMATERIAL8 *lpMaterials;
	LPDIRECT3DTEXTURE8 *lpTextures;
	DWORD nMaterials;
} *lpCue;

int cue,nCues; 

struct _b{ 
	LPD3DXMESH lpBall;
	D3DMATERIAL8 *lpBallMaterials;
	LPDIRECT3DTEXTURE8 *lpBallTextures;
	DWORD nBallMaterials;
	BOOL show;
	BOOL pocketing;
	int pocket; // added which pocket 
	D3DXVECTOR3 pos;
	D3DXVECTOR3 dir;
	D3DXMATRIX rot;
	float speed;
}ball[23];  // 0 = cue 1>15 normal : 16 black 17 pink 18 blue 19 brown 20 green 21 yellow 22 red

BOOL ShowCue=TRUE; // when balls in motion hide cue 
int ballType=0; // 0=us 1=uk 
int nPockets=0;
D3DXVECTOR3 pocket[10];
BOOL Desktop8Bit=FALSE;
BOOL quit=FALSE;

UINT nAdapters;
struct _m{
 	char Description[MAX_DEVICE_IDENTIFIER_STRING];
	UINT nModes;
	D3DDISPLAYMODE DisplayMode; 
	D3DDISPLAYMODE *pModes;
}*pAdapterModes;



void lights()   // called from InitD3D to create overhead light 
{
	D3DLIGHT8 light;
	ZeroMemory( &light, sizeof(D3DLIGHT8) );
	light.Type = D3DLIGHT_POINT; //D3DLIGHT_DIRECTIONAL;
	light.Diffuse.r = light.Diffuse.g =	light.Diffuse.b = 1.0f; // white light 
	light.Specular.a = light.Specular.r = light.Specular.g = light.Specular.b =1.0f ; 

	light.Position = D3DXVECTOR3( 0.0f,5.0f,0.0f );   // 50m up could add to scene.x notes sdk sais light should be far for specular to work 
	light.Range = 20.0f; 
	light.Attenuation0 = 1.0f;

	lpD3DDevice->SetLight( 0, &light );
	lpD3DDevice->LightEnable( 0, TRUE );
	lpD3DDevice->SetRenderState(D3DRS_SPECULARENABLE, specular);
	lpD3DDevice->SetRenderState(D3DRS_SHADEMODE, D3DSHADE_GOURAUD );

	lpD3DDevice->SetRenderState( D3DRS_AMBIENT, ambient[hdtv] ); // ambient TODO gamma , blue hint , 'h' hdtv wide mode

	// fog 
	float start=4.0f,end=6.0f,density=0.2f;

	lpD3DDevice->SetRenderState( D3DRS_FOGENABLE, fog ); 
	lpD3DDevice->SetRenderState( D3DRS_FOGCOLOR, 0 ); // black
	lpD3DDevice->SetRenderState( D3DRS_FOGTABLEMODE,D3DFOG_EXP2);  // or Linear
	lpD3DDevice->SetRenderState( D3DRS_FOGDENSITY,*(DWORD*)(&density) );
}

void Check8BitDesktop()
{
	DEVMODE Desktop;
	Desktop.dmSize=sizeof(DEVMODE);
	Desktop.dmDriverExtra=0;

	EnumDisplaySettings(NULL,ENUM_CURRENT_SETTINGS,&Desktop);

	if(Desktop.dmBitsPerPel==8)
	{
		MessageBox(NULL,"Windowed mode unavalible in 8 bit Color","",MB_OK|MB_ICONINFORMATION);
		Desktop8Bit=TRUE; 		
	}		
}

HRESULT Enum()
{
	Check8BitDesktop(); // Desktop8Bit TRUE if 8bit color, warning 

	if(NULL==(lpD3D=Direct3DCreate8(D3D_SDK_VERSION) ))	{
		MessageBox(NULL,"Direct3DCreate8","Error",MB_OK); return E_FAIL;
	}

	nAdapters=lpD3D->GetAdapterCount();
	pAdapterModes=new _m[nAdapters];
	D3DADAPTER_IDENTIFIER8 pId;

	for(UINT a=0;a<nAdapters;a++) // per adapter
	{
		// Adapter Mode
		if(FAILED(lpD3D->GetAdapterDisplayMode(a,&pAdapterModes[a].DisplayMode) )) {
			MessageBox(NULL,"GetAdapterDisplayMode","Error",MB_OK); return E_FAIL;
		}
		// Adapter Description
		if(FAILED(lpD3D->GetAdapterIdentifier(a,D3DENUM_NO_WHQL_LEVEL,&pId) )) {
			MessageBox(NULL,"GetAdapterIdentifier","Error",MB_OK); return E_FAIL;
		}
		wsprintf(pAdapterModes[a].Description,pId.Description);

		// Number of Modes per Adapter
		UINT nModes=lpD3D->GetAdapterModeCount(a);
		pAdapterModes[a].pModes=new D3DDISPLAYMODE[nModes];
		pAdapterModes[a].nModes=0;
		D3DDISPLAYMODE d3ddm;

		for(UINT m=0;m<nModes;m++)
		{
			if(FAILED(lpD3D->EnumAdapterModes(a,m,&d3ddm) )){
				MessageBox(NULL,"EnumAdapterModes","Error",MB_OK); return E_FAIL;
			}
			if(d3ddm.Height>=480)
			{
				pAdapterModes[a].pModes[pAdapterModes[a].nModes]=d3ddm;
				pAdapterModes[a].nModes++;
			}
		}
	}
	return S_OK;
}

HRESULT InitD3D(HWND hwnd)
{
	ZeroMemory(&d3dpp,sizeof(d3dpp) );  

	if(Windowed)
	{
		if(FAILED(lpD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT,&d3ddm) )) return E_FAIL;
		d3dpp.BackBufferFormat=d3ddm.Format;   // width,height=0 means use clientarea 
	}else{
		d3dpp.BackBufferWidth=pAdapterModes[uAdapter].pModes[uMode].Width;
		d3dpp.BackBufferHeight=pAdapterModes[uAdapter].pModes[uMode].Height;
		d3dpp.BackBufferFormat=pAdapterModes[uAdapter].pModes[uMode].Format;
		d3dpp.FullScreen_RefreshRateInHz=pAdapterModes[uAdapter].pModes[uMode].RefreshRate;
	}

	d3dpp.Windowed=Windowed;
	d3dpp.SwapEffect=D3DSWAPEFFECT_DISCARD;
	d3dpp.EnableAutoDepthStencil=TRUE; 
	d3dpp.AutoDepthStencilFormat=D3DFMT_D16;  // test, need stencil for shadows 

	if(FAILED(lpD3D->CreateDevice(uAdapter,D3DDEVTYPE_HAL,hwnd,
		D3DCREATE_SOFTWARE_VERTEXPROCESSING,&d3dpp,&lpD3DDevice) )) return E_FAIL;

	lpD3DDevice->SetRenderState(D3DRS_ZENABLE,TRUE); // z buffer 
	lpD3DDevice->SetTextureStageState(0,D3DTSS_MAGFILTER,D3DTEXF_LINEAR );
	lpD3DDevice->SetTextureStageState(0,D3DTSS_MINFILTER,D3DTEXF_LINEAR );
	lights(); // set lights and enable 	

	if(FAILED(LoadGeometry() )) return E_FAIL; // also loads gamedata     
	
	return S_OK;
}

void LoadTableData() //mod
{
	int val=0;
	if(table==0)
	{
		nPockets=(int)table0[val++];
		pocketRadius=table0[val++];
		for(int p=0;p<nPockets;p++)
		{
			pocket[p].x=table0[val++]; pocket[p].z=table0[val++];
			pocket[p].y=0.0f;
		}
		tableHeight=table0[val++];
		EyeY=table0[val++];
		viewDistFromCueBall=table0[val++];
		RotY=table0[val++];
		minEyeY=table0[val++]; maxEyeY=table0[val++];
	}

	if(table==1)
	{
		nPockets=(int)table1[val++];
		pocketRadius=table1[val++];
		for(int p=0;p<nPockets;p++)
		{
			pocket[p].x=table1[val++]; pocket[p].z=table1[val++];
			pocket[p].y=0.0f;
		}
		tableHeight=table1[val++];
		EyeY=table1[val++];
		viewDistFromCueBall=table1[val++];
		RotY=table1[val++];
		minEyeY=table1[val++]; maxEyeY=table1[val++];
	}

	if(table==2)
	{
		nPockets=(int)table2[val++];
		pocketRadius=table2[val++];
		for(int p=0;p<nPockets;p++)
		{
			pocket[p].x=table2[val++]; pocket[p].z=table2[val++];
			pocket[p].y=0.0f;
		}
		tableHeight=table2[val++];
		EyeY=table2[val++];
		viewDistFromCueBall=table2[val++];
		RotY=table2[val++];
		minEyeY=table2[val++]; maxEyeY=table2[val++];
	}

	val=0;
	if(table==0)
	{
		nCPoints=(int)cush0[val++];
		for(int p=0;p<nCPoints;p++)
		{
			cPoints[p].y=0.0f; cPoints[p].x=cush0[val++]; cPoints[p].z=cush0[val++];
		}
	}

	if(table==1)
	{
		nCPoints=(int)cush1[val++];
		for(int p=0;p<nCPoints;p++)
		{
			cPoints[p].y=0.0f; cPoints[p].x=cush1[val++]; cPoints[p].z=cush1[val++];
		}
	}

	if(table==2)
	{
		nCPoints=(int)cush2[val++];
		for(int p=0;p<nCPoints;p++)
		{
			cPoints[p].y=0.0f; cPoints[p].x=cush2[val++]; cPoints[p].z=cush2[val++];
		}
	}
}

void LoadGameData() 
{
	LoadTableData(); // table 

	ballDiameter=0.057f; ballRadius=ballDiameter/2.0f;
	cueminfromball=0.01f; cuemaxfromball=0.3f;
	cueViewMin=0.1f; cueViewMax=4.0f;
}

void ResetBalls()
{
	for(int b=0;b<23;b++)
	{
		ball[b].dir=D3DXVECTOR3(0.0f,0.0f,-1.0f); // ??? bug initial collide
		ball[b].speed=0.0f;
		ball[b].pocketing=FALSE;
		ball[b].pocket=0;
		D3DXMatrixIdentity(&ball[b].rot);
		ball[b].show=FALSE;
		ball[b].pos=D3DXVECTOR3(-5.0f,0.0f,0.0f); // off table 
	}

	if(GameType==9)
	{
	for(int p=0;p<GameType+1;p++)
		{
			ball[p].pos.x=ball9x[p]; ball[p].pos.z=ball9z[p]; 
			ball[p].pos.y=tableHeight+ballRadius; 
			ball[p].show=TRUE;
		}
	}


	if(GameType==15)
	{
	for(int p=0;p<GameType+1;p++)
		{
			ball[p].pos.x=ball15x[p]; ball[p].pos.z=ball15z[p]; 
			ball[p].pos.y=tableHeight+ballRadius; 
			ball[p].show=TRUE;
		}
	}


	if(GameType==21)
	{
	for(int p=0;p<GameType+1;p++)
		{
			ball[p].pos.x=ball21x[p]; ball[p].pos.z=ball21z[p]; 
			ball[p].pos.y=tableHeight+ballRadius; 
			ball[p].show=TRUE;
		}
	}
}

HRESULT LoadTableCloths()
{
	lpTableClothTextures=new LPDIRECT3DTEXTURE8[6];

	char szFile[MAX_PATH],szCurrent[MAX_PATH];
	int cLen=GetCurrentDirectory(MAX_PATH,szCurrent);

	for(int C=0;C<6;C++)
	{
		wsprintf(szFile,"cloth%d.jpg",C);
	
		DWORD cbData;
		HGLOBAL hgData;
	    LPVOID pvData;
		HRSRC rsrc=FindResource(NULL,szFile,"JPG");
		if(rsrc!=NULL)
		{
			cbData=SizeofResource(NULL,rsrc);
			if(cbData>0)
			{
				hgData=LoadResource(NULL,rsrc);
				if(hgData!=NULL)
				{
					pvData=LockResource(hgData);
					if(pvData!=NULL)
					{
						if(FAILED(D3DXCreateTextureFromFileInMemoryEx(
							lpD3DDevice,pvData,cbData,D3DX_DEFAULT,D3DX_DEFAULT,
							1,0,D3DFMT_UNKNOWN,D3DPOOL_MANAGED,D3DX_FILTER_NONE,
							D3DX_FILTER_NONE,0,NULL,NULL,&lpTableClothTextures[C] ) ) )
							{
							MessageBeep(0); return E_FAIL;
							}
					}
				}
			}
		}
	}
	return S_OK;
}

HRESULT LoadTables()
{
	char szFile[MAX_PATH];
	LPD3DXBUFFER lpD3DXMtrlBuffer;
	lpTable=new _table[nTables];

	for(int t=0;t<nTables;t++)
	{
		wsprintf(szFile,"table%d.x",t); // ie resource from tables/table0.x

		if(FAILED(D3DXLoadMeshFromXResource(GetModuleHandle(NULL),    //dx8.1 
			szFile,"XFILE",D3DXMESH_MANAGED,    // changed from SYSTEMMEM 
				lpD3DDevice,NULL,&lpD3DXMtrlBuffer,&lpTable[t].nMaterials,&lpTable[t].lpMesh) ))
		{
			MessageBeep(0); return E_FAIL;
		}

		D3DXMATERIAL* d3dxMaterials=(D3DXMATERIAL*)lpD3DXMtrlBuffer->GetBufferPointer();
		lpTable[t].lpMaterials=new D3DMATERIAL8[lpTable[t].nMaterials];
		lpTable[t].lpTextures=new LPDIRECT3DTEXTURE8[lpTable[t].nMaterials];
   
		for(DWORD i=0; i<lpTable[t].nMaterials; i++ )
		{
			lpTable[t].lpMaterials[i]=d3dxMaterials[i].MatD3D;
			lpTable[t].lpMaterials[i].Ambient=lpTable[t].lpMaterials[i].Diffuse;
		
			lpTable[t].lpTextures[i]=NULL;
			if(d3dxMaterials[i].pTextureFilename !=NULL &&
				lstrlen(d3dxMaterials[i].pTextureFilename)>0)
			{
				// Create the texture
				wsprintf(szFile,"%s",d3dxMaterials[i].pTextureFilename);
				int test=strcmp(d3dxMaterials[i].pTextureFilename,"cloth1.jpg");
				if(test==0)
				{
					tableCloth[t][i]=1; 	
				}
//
				DWORD cbData;
				HGLOBAL hgData;
			    LPVOID pvData;
				HRSRC rsrc=FindResource(NULL,szFile,"JPG");
				if(rsrc!=NULL)
				{
					cbData=SizeofResource(NULL,rsrc);
					if(cbData>0)
					{
						hgData=LoadResource(NULL,rsrc);
						if(hgData!=NULL)
						{
							pvData=LockResource(hgData);
							if(pvData!=NULL)
							{
								if(FAILED(D3DXCreateTextureFromFileInMemoryEx(
									lpD3DDevice,pvData,cbData,D3DX_DEFAULT,D3DX_DEFAULT,
									1,0,D3DFMT_UNKNOWN,D3DPOOL_MANAGED,D3DX_FILTER_NONE,
									D3DX_FILTER_NONE,0,NULL,NULL,&lpTable[t].lpTextures[i] ) ) )
								{
								MessageBeep(0); return E_FAIL;
								}
							}
						}
					}
				}
			}
		}
		lpD3DXMtrlBuffer->Release();
	}
	return S_OK;
}

HRESULT LoadCues()
{
	char szFile[MAX_PATH];

	LPD3DXBUFFER lpD3DXMtrlBuffer;
	nCues=3; // load from file 
	lpCue=new _cue[nCues];

	for(int c=0;c<nCues;c++)
	{
		wsprintf(szFile,"cue%d.x",c); // ie cue0.x

		if(FAILED(D3DXLoadMeshFromXResource(GetModuleHandle(NULL)
			,szFile,"XFILE",D3DXMESH_MANAGED,
				lpD3DDevice,NULL,&lpD3DXMtrlBuffer,&lpCue[c].nMaterials,&lpCue[c].lpMesh) ))
		{
			MessageBeep(0); return E_FAIL;
		}

		D3DXMATERIAL* d3dxMaterials=(D3DXMATERIAL*)lpD3DXMtrlBuffer->GetBufferPointer();
		lpCue[c].lpMaterials=new D3DMATERIAL8[lpCue[c].nMaterials];
		lpCue[c].lpTextures=new LPDIRECT3DTEXTURE8[lpCue[c].nMaterials];
   
		for(DWORD i=0; i<lpCue[c].nMaterials; i++ )
		{
			lpCue[c].lpMaterials[i]=d3dxMaterials[i].MatD3D;
			lpCue[c].lpMaterials[i].Ambient=lpCue[c].lpMaterials[i].Diffuse;

			lpCue[c].lpTextures[i]=NULL;
			if(d3dxMaterials[i].pTextureFilename !=NULL &&
				lstrlen(d3dxMaterials[i].pTextureFilename)>0)
			{
				// Create the texture
				wsprintf(szFile,"%s",d3dxMaterials[i].pTextureFilename);

				DWORD cbData;
				HGLOBAL hgData;
			    LPVOID pvData;
				HRSRC rsrc=FindResource(NULL,szFile,"JPG");
				if(rsrc!=NULL)
				{
					cbData=SizeofResource(NULL,rsrc);
					if(cbData>0)
					{
						hgData=LoadResource(NULL,rsrc);
						if(hgData!=NULL)
						{
							pvData=LockResource(hgData);
							if(pvData!=NULL)
							{
								if(FAILED(D3DXCreateTextureFromFileInMemoryEx(
									lpD3DDevice,pvData,cbData,D3DX_DEFAULT,D3DX_DEFAULT,
									1,0,D3DFMT_UNKNOWN,D3DPOOL_MANAGED,D3DX_FILTER_NONE,
									D3DX_FILTER_NONE,0,NULL,NULL,&lpCue[c].lpTextures[i] ) ) )
								{
								MessageBeep(0); return E_FAIL;
								}
							}
						}
					}
				}
			}
		}
		lpD3DXMtrlBuffer->Release();
	}
	return S_OK;
}

HRESULT LoadGeometry()
{
	LoadGameData(); // loads game data 

	char szFile[MAX_PATH];
	LPD3DXBUFFER lpD3DXMtrlBuffer;

	// load shadow
	if(FAILED(D3DXLoadMeshFromXResource(GetModuleHandle(NULL),
		"shadow.x","XFILE",D3DXMESH_MANAGED,
				lpD3DDevice,NULL,&lpD3DXMtrlBuffer,&nShadowMaterials,&lpShadow) )) return E_FAIL;

    D3DXMATERIAL* d3dxMaterials=(D3DXMATERIAL*)lpD3DXMtrlBuffer->GetBufferPointer();
    lpShadowMaterials=new D3DMATERIAL8[nShadowMaterials];
	lpShadowTextures=new LPDIRECT3DTEXTURE8[nShadowMaterials];
   
    for( DWORD i=0; i<nShadowMaterials; i++ )
    {
        lpShadowMaterials[i]=d3dxMaterials[i].MatD3D;
        lpShadowMaterials[i].Ambient=lpShadowMaterials[i].Diffuse;

		lpShadowTextures[i]=NULL;
		if(d3dxMaterials[i].pTextureFilename !=NULL &&
			lstrlen(d3dxMaterials[i].pTextureFilename)>0)
		{
			// Create the texture
			wsprintf(szFile,"%s",d3dxMaterials[i].pTextureFilename);

			DWORD cbData;
			HGLOBAL hgData;
			LPVOID pvData;
			HRSRC rsrc=FindResource(NULL,szFile,"JPG");
			if(rsrc!=NULL)
			{
				cbData=SizeofResource(NULL,rsrc);
				if(cbData>0)
				{
					hgData=LoadResource(NULL,rsrc);
					if(hgData!=NULL)
					{
						pvData=LockResource(hgData);
						if(pvData!=NULL)
						{
							if(FAILED(D3DXCreateTextureFromFileInMemoryEx(
								lpD3DDevice,pvData,cbData,D3DX_DEFAULT,D3DX_DEFAULT,
								1,0,D3DFMT_UNKNOWN,D3DPOOL_MANAGED,D3DX_FILTER_NONE,
								D3DX_FILTER_NONE,0,NULL,NULL,&lpShadowTextures[i] ) ) )
							{
							MessageBeep(0); return E_FAIL;
							}
						}
					}
				}
			}

		}
    }
    lpD3DXMtrlBuffer->Release();

	if(FAILED(LoadTables() )) return E_FAIL;
	if(FAILED(LoadTableCloths() )) return E_FAIL; // loads table cloths 

	// load scene 

	if(FAILED(D3DXLoadMeshFromXResource(GetModuleHandle(NULL),
		"scene.x","XFILE",D3DXMESH_MANAGED,
				lpD3DDevice,NULL,&lpD3DXMtrlBuffer,&nSceneMaterials,&lpScene) )) return E_FAIL;

    d3dxMaterials=(D3DXMATERIAL*)lpD3DXMtrlBuffer->GetBufferPointer();
    lpSceneMaterials=new D3DMATERIAL8[nSceneMaterials];
	lpSceneTextures=new LPDIRECT3DTEXTURE8[nSceneMaterials];
   
    for( i=0; i<nSceneMaterials; i++ )
    {
        lpSceneMaterials[i]=d3dxMaterials[i].MatD3D;
        lpSceneMaterials[i].Ambient=lpSceneMaterials[i].Diffuse;

		lpSceneTextures[i]=NULL;
		if(d3dxMaterials[i].pTextureFilename !=NULL &&
			lstrlen(d3dxMaterials[i].pTextureFilename)>0)
		{
			// Create the texture
			wsprintf(szFile,"%s",d3dxMaterials[i].pTextureFilename);

			DWORD cbData;
			HGLOBAL hgData;
			LPVOID pvData;
			HRSRC rsrc=FindResource(NULL,szFile,"JPG");
			if(rsrc!=NULL)
			{
				cbData=SizeofResource(NULL,rsrc);
				if(cbData>0)
				{
					hgData=LoadResource(NULL,rsrc);
					if(hgData!=NULL)
					{
						pvData=LockResource(hgData);
						if(pvData!=NULL)
						{
							if(FAILED(D3DXCreateTextureFromFileInMemoryEx(
								lpD3DDevice,pvData,cbData,D3DX_DEFAULT,D3DX_DEFAULT,
								1,0,D3DFMT_UNKNOWN,D3DPOOL_MANAGED,D3DX_FILTER_NONE,
								D3DX_FILTER_NONE,0,NULL,NULL,&lpSceneTextures[i] ) ) )
							{
							MessageBeep(0); return E_FAIL;
							}
						}
					}
				}
			}
		}
    }
    lpD3DXMtrlBuffer->Release();

	// load cues 
	if(FAILED(LoadCues() )) return E_FAIL;

	// load balls
	for(int b=0;b<23;b++)
	{
		ball[b].nBallMaterials=0; // temp
		wsprintf(szFile,"%dball.x",b);
		if(FAILED(D3DXLoadMeshFromXResource(GetModuleHandle(NULL),szFile,"XFILE",
			D3DXMESH_MANAGED,lpD3DDevice,NULL,&lpD3DXMtrlBuffer,
			&ball[b].nBallMaterials,&ball[b].lpBall) )) return E_FAIL;

		d3dxMaterials=(D3DXMATERIAL*)lpD3DXMtrlBuffer->GetBufferPointer();
		ball[b].lpBallMaterials=new D3DMATERIAL8[ball[b].nBallMaterials];
		ball[b].lpBallTextures=new LPDIRECT3DTEXTURE8[ball[b].nBallMaterials];
   
		for( i=0; i<ball[b].nBallMaterials; i++ )
		{
			ball[b].lpBallMaterials[i]=d3dxMaterials[i].MatD3D;
			ball[b].lpBallMaterials[i].Ambient=ball[b].lpBallMaterials[i].Diffuse;

			// specular highlights 
		ball[b].lpBallMaterials[i].Specular.g=ball[b].lpBallMaterials[i].Specular.b=ball[b].lpBallMaterials[i].Specular.r=ball[b].lpBallMaterials[i].Specular.a=1.0f;
		ball[b].lpBallMaterials[i].Power=30.0f; 

			ball[b].lpBallTextures[i]=NULL;
			if(d3dxMaterials[i].pTextureFilename !=NULL &&
				lstrlen(d3dxMaterials[i].pTextureFilename)>0)
			{
				// Create the texture
				wsprintf(szFile,"%s",d3dxMaterials[i].pTextureFilename);
				
				DWORD cbData;
				HGLOBAL hgData;
			    LPVOID pvData;
				HRSRC rsrc=FindResource(NULL,szFile,"JPG");
				if(rsrc!=NULL)
				{
					cbData=SizeofResource(NULL,rsrc);
					if(cbData>0)
					{
						hgData=LoadResource(NULL,rsrc);
						if(hgData!=NULL)
						{
							pvData=LockResource(hgData);
							if(pvData!=NULL)
							{
								if(FAILED(D3DXCreateTextureFromFileInMemoryEx(
									lpD3DDevice,pvData,cbData,D3DX_DEFAULT,D3DX_DEFAULT,
									1,0,D3DFMT_UNKNOWN,D3DPOOL_MANAGED,D3DX_FILTER_NONE,
									D3DX_FILTER_NONE,0,NULL,NULL,&ball[b].lpBallTextures[i] ) ) )
								{
								MessageBeep(0); return E_FAIL;
								}
							}
						}
					}
				}
			}
		}
		lpD3DXMtrlBuffer->Release();
	}
    return S_OK;
}

void Cleanup()
{
	if(lpTableClothTextures)
	{
		for(int C=0;C<6;C++)
		{
			if(lpTableClothTextures[C])
				lpTableClothTextures[C]->Release();
		}
		delete[] lpTableClothTextures;
	}

	if(lpShadowMaterials!=NULL) delete[] lpShadowMaterials;
	if(lpShadowTextures)
	{
		for(DWORD i=0;i<nShadowMaterials;i++)
		{
			if(lpShadowTextures[i])
				lpShadowTextures[i]->Release();
		}
		delete[] lpShadowTextures;
	}
	SafeRelease(lpShadow);

	for(int t=0;t<nTables;t++)
	{
		if(lpTable[t].lpMaterials!=NULL) delete[] lpTable[t].lpMaterials;
		if(lpTable[t].lpTextures)
		{
			for(DWORD i=0;i<lpTable[t].nMaterials;i++)
			{
				if(lpTable[t].lpTextures[i])
					lpTable[t].lpTextures[i]->Release();
			}
			delete[] lpTable[t].lpTextures;
		}
		SafeRelease(lpTable[t].lpMesh);
	}

	for(int c=0;c<nCues;c++)
	{
		if(lpCue[c].lpMaterials!=NULL) delete[] lpCue[c].lpMaterials;
		if(lpCue[c].lpTextures)
		{
			for(DWORD i=0;i<lpCue[c].nMaterials;i++)
			{
				if(lpCue[c].lpTextures[i])
					lpCue[c].lpTextures[i]->Release();
			}
			delete[] lpCue[c].lpTextures;
		}
		SafeRelease(lpCue[c].lpMesh);
	}

	if(lpSceneMaterials!=NULL) delete[] lpSceneMaterials;
	if(lpSceneTextures)
	{
		for(DWORD i=0;i<nSceneMaterials;i++)
		{
			if(lpSceneTextures[i])
				lpSceneTextures[i]->Release();
		}
		delete[] lpSceneTextures;
	}
	SafeRelease(lpScene);

	for(int b=0;b<23;b++)
	{
	if(ball[b].lpBallMaterials!=NULL) delete[] ball[b].lpBallMaterials;
	if(ball[b].lpBallTextures)
	{
		for(DWORD i=0;i<ball[b].nBallMaterials;i++)
		{
			if(ball[b].lpBallTextures[i])
				ball[b].lpBallTextures[i]->Release();
		}
		delete[] ball[b].lpBallTextures;
	}
	SafeRelease(ball[b].lpBall);
	}

	SafeRelease(lpD3DDevice);
	SafeRelease(lpD3D);

	CleanupDMusic();
	CleanupDInput();
}

// physics code

void MoveBall(int a,float percent) // percent = 0 to 1 (100 %)
{
	ball[a].pos+=ball[a].speed*ball[a].dir*time_elapsed*percent;
}

float whitemin=0.4f,whitemax=1.0f;

BOOL ReplaceWhite() 
{
	for(float p=whitemin;p<whitemax;p+=0.01f) 
	{
		float d=ballDiameter; // min distance between balls 
		for(int n=1;n<23;n++)
		{
			D3DXVECTOR3 aa,bb,cc;
			aa=D3DXVECTOR3(-p,tableHeight+ballRadius,0.0f); // place to put cue ball
			bb=D3DXVECTOR3(ball[n].pos); // other ball pos
			cc=bb-aa; // distance between balls 
			if(D3DXVec3Length(&cc)<d) d=D3DXVec3Length(&cc); // if any ball is too close reduce d and make invalid placement
		}
		// if d< balldiameter ie any ball is too close try again else place 
		if(d>=ballDiameter) // if not too close 
		{
			ball[0].pos=D3DXVECTOR3(-p,tableHeight+ballRadius,0.0f);
			ball[0].speed=0.0f;
			ball[0].pocketing=FALSE;
			return TRUE; 
		}
	}
	return FALSE;
}	

// add when too far but heading to point a or b ie hit corner of cushon 

void ColCushons(int a) // per non-pocketing ball 
{
	D3DXVECTOR3 A,B,C,AB,AC,BC,N,M,up;
	D3DXMATRIX rotY;
	float lenAC,lenAB,lenBC,DP,rot; // A,B,C
	float D; // distance 
	BOOL Col=FALSE;

	for(int npoint=0;npoint<nCPoints-1;npoint++) // each pair of points ( edge )
	{
		A=D3DXVECTOR3(cPoints[npoint].x,0.0f,cPoints[npoint].z);
		B=D3DXVECTOR3(cPoints[npoint+1].x,0.0f,cPoints[npoint+1].z);
		C=D3DXVECTOR3(ball[a].pos.x,0.0f,ball[a].pos.z);
		//A,B,C are our 3 points of a triangle  A>B = cushon C= Ball
		// get 3 sides length 
		AC=C-A;
		AB=B-A;
		BC=C-B;
		lenAC=D3DXVec3Length(&AC);
		lenAB=D3DXVec3Length(&AB);
		lenBC=D3DXVec3Length(&BC);		

		if(lenAC<lenAB && lenBC<lenAB) // if Ball near enough to edge do test
		{
			DP=((AC.x*AB.x)+(AC.z*AB.z)); // dot product 
			DP=DP/(lenAC*lenAB);
			DP=(float)acos(DP); // now we have angle a@ corner A 

			D=lenAC*(float)sin(DP); // D is distance C to side AB f/sin(F) rule or AC/sin90(1) 

			if(D<ballRadius) // too near edge 
			{ 
				Col=TRUE;
				MoveBall(a,-1.0f); // move back one step
				MoveBall(a,(D/ballRadius) ); // move forward till collide  	
				PlayBounce();   //bug vibrates if stuck on cushion 
				// collision response is change direction 
					
				// get normal of AB,up 
				up=D3DXVECTOR3(0.0f,1.0f,0.0f);
				D3DXVec3Normalize(&AB,&AB);
				D3DXVec3Cross(&N,&AB,&up); // get normal 
				M=ball[a].dir; 
				DP=((N.x*M.x)+(N.z*M.z)); // dot product 
				
				if(DP>0.0f) // if <90 ie moving towards edge
				{
					DP=(float)acos(DP); // angle between ball.dir and wall angle of incidence 
					
					if(DP>D3DX_PI/4)
					{
						rot=2.0f*((D3DX_PI/2)-DP);
					}
					else
					{
						rot=(D3DX_PI)-(2.0f*DP); 
					}
					// also need cross product for angle + or - 
					D3DXVec3Cross(&up,&M,&N);

					if(up.y<0.0f) D3DXMatrixRotationY(&rotY,rot);
					else D3DXMatrixRotationY(&rotY,-rot);
					D3DXVec3TransformCoord(&ball[a].dir,&ball[a].dir,&rotY);
					ball[a].dir.y=0.0f;
				}
				MoveBall(a,1.0f-(D/ballRadius) ); // move rest of way
			}				
		}
	}
}

void ColPocket(int a) // seems to reduce balls floating away 
{
	ball[a].pos.x=min(ball[a].pos.x,pocket[ball[a].pocket].x+pocketRadius);
	ball[a].pos.x=max(ball[a].pos.x,pocket[ball[a].pocket].x-pocketRadius);
	ball[a].pos.z=min(ball[a].pos.z,pocket[ball[a].pocket].z+pocketRadius);
	ball[a].pos.z=max(ball[a].pos.z,pocket[ball[a].pocket].z-pocketRadius);
}

void Pocketing(int a) // per ball 
{
	// is the ball in a pocket ?
	if(!ball[a].pocketing) // obvious don't test if already flagged
	{
		for(int p=0;p<nPockets;p++) 
		{
			D3DXVECTOR3 A=D3DXVECTOR3(ball[a].pos.x,0.0f,ball[a].pos.z); // ball pos x,z
			D3DXVECTOR3 B=D3DXVECTOR3(pocket[p].x,0.0f,pocket[p].z); // pocket x,z  
			D3DXVECTOR3 C=B-A; 

			float d=D3DXVec3Length(&C); // distance from ball centre to pocket centre 
			if(d<=pocketRadius){
				ball[a].pocketing=TRUE; // ie centre of ball has passed over rim of pocket 
				ball[a].pocket=p; // tell which pocket to limit to 
			}
		}
	}

	// if the ball is on a pocket	
	if(ball[a].pocketing) 
	{		
		// change to sin/cos projectile 
		D3DXVECTOR3 up=D3DXVECTOR3(0.0f,1.0f,0.0f);
		if(gravup)up=D3DXVECTOR3(0.0f,-1.0f,0.0f); // floats up 
		D3DXVECTOR3 axis;
		D3DXMATRIX rot;

		if(fabs(ball[a].dir.y)<0.95f) // possible error if totally in direction 
		{
		D3DXVec3Cross(&axis,&up,&ball[a].dir); // axis to rotate pocketing ball by 
		D3DXMatrixRotationAxis(&rot,&axis,D3DX_PI*time_elapsed);
		D3DXVec3TransformCoord(&ball[a].dir,&ball[a].dir,&rot);
		}

		ball[a].speed+=9.8f*time_elapsed; // gravity 

		if(ball[a].pos.y>10.0f && gravup){
			ball[a].speed=0.0f; // just for fun with up=down 
			ball[a].pos.y=0.0f; // pocketed 
		}
			
		if(a==0) // never hide white 
		{
			if(ball[0].pos.y<tableHeight-ballDiameter){ // or ball[0].pocketing 
				ReplaceWhite();
				PlayPot(); // sound 
			}
			return; // keep from hiding and moving 
		}
		if(a==8 && GameType==15)    // add logic for snooker ==21 
		{
			if(ball[8].pos.y<tableHeight-ballDiameter){
				ResetBalls(); 
				PlayPot();
			} 
			return;
		}

		if(a==9 && GameType==9) 
		{
			if(ball[9].pos.y<tableHeight-ballDiameter){
				ResetBalls(); 
				PlayPot();
			}
			return; 
		}
		
		if(ball[a].pos.y<tableHeight-ballDiameter)
		{ 
			ball[a].show=FALSE; 
			ball[a].pos=D3DXVECTOR3(0.0f,0.0f,0.0f); // move temp off table ???? 
			PlayPot();
		}						
		return;
	}
}

float BallsCollisions(int a,int b) // returns value of collision as percentage
{
	if(ball[a].pos.y<(tableHeight+ballRadius) || ball[b].pos.y<(tableHeight+ballRadius) ) return 0.0f; // ignore dropping 
	// test 1 
	D3DXVECTOR3 V=(ball[a].dir*ball[a].speed*time_elapsed)-
		(ball[b].dir*ball[b].speed*time_elapsed); // travel distance
	D3DXVECTOR3 C=ball[b].pos-ball[a].pos; // distance between centres 
	C.y=0.0f; // 2d 

	float v=D3DXVec3Length(&V);  // distance to travel per frame 
	float c=D3DXVec3Length(&C);  // distance between balls 

	if(v<(c-ballDiameter)) return 0.0f; // no collision no travel enough this frame 

	// test 2 
	float cdotv=D3DXVec3Dot(&V,&C);
	if(cdotv<=0) return 0.0f; // no collision if different direction ???? 

	// test 3
	D3DXVECTOR3 N;
	D3DXVec3Normalize(&N,&V);

	float d=D3DXVec3Dot(&N,&C); // distance from centre a to min dist from b 
	float f=(float)sqrt((c*c)-(d*d)); // min distance from v to centre B 

	if(f>ballDiameter) return 0.0f; // goes past without touching 

	// test 4 
	float t=(float)sqrt((ballDiameter*ballDiameter)-(f*f));
	d-=t; // gives distance to touch ball B 

	if(v<d) return 0.0f; // not far enough to touch

	// must be collision so move ball a up to ball b and b up to a 
	return d/v;  // ie if v=3cm and d=2cm to min dist to b centre 2/3 is perecent of V to travel 
}

void CalcBallBounce(int a,int b)
{
	D3DXVECTOR3 n=ball[a].pos-ball[b].pos; // direction at collision
	n.y=0.0f; // 2d 
	D3DXVec3Normalize(&n,&n); // direction at collision 

	D3DXVECTOR3 v1,v2,v1n,v2n;
	v1=ball[a].dir*ball[a].speed*time_elapsed;
	v2=ball[b].dir*ball[b].speed*time_elapsed;

	float a1=D3DXVec3Dot(&v1,&n);
	float a2=D3DXVec3Dot(&v2,&n);

	float op=(2.0f*(a1-a2))/(1.0f+1.0f); // mass = 1.0 kg 

	v1n=v1-(op*1.0f*n);
	v2n=v2+(op*1.0f*n);

	ball[a].dir=v1n;
	ball[b].dir=v2n;

	D3DXVec3Normalize(&ball[a].dir,&ball[a].dir);  
	D3DXVec3Normalize(&ball[b].dir,&ball[b].dir);  

	ball[a].speed=D3DXVec3Length(&v1n)/time_elapsed;
	ball[b].speed=D3DXVec3Length(&v2n)/time_elapsed;
}

void GamePhysics()
{
	// test for striking cue ball
	if(CueFromBall<(ballRadius) && ShowCue)	// shoot white ball 
	{									
		ball[0].speed=CueSpeed/7.0f; // cue is 7.0* mass of ball
		ball[0].dir=-nCue;	
		D3DXVec3Normalize(&ball[0].dir,&ball[0].dir);
		PlayStrike();
	}
	if(!ShowCue)cueSlant=0.1f; // reset slant 

	ShowCue=TRUE; // later will be set to false if any balls moving 
	D3DXVECTOR3 axis;
	D3DXMATRIX temp,rot;

	for(int a=0;a<23;a++)  // for every ball 
	{   
		if(ball[a].show) // unshown balls are in the tray 
		{
		ball[a].speed*=1.0f-(coef_friction*time_elapsed); // slow down balls 0.7 = friction 1m/s ? 

		if(ball[a].speed<(0.1f))  // stop slow balls < 10cm/sec ie friction to stop ball
			ball[a].speed=0.0f; 
		else 
			ShowCue=FALSE; // ie any moving ball hide cue 		

		D3DXMatrixRotationY(&temp,D3DX_PI/2); // ball rotation axis is at right angles to direction 
		D3DXVec3TransformCoord(&axis,&ball[a].dir,&temp);
		D3DXMatrixRotationAxis(&rot,&axis,ball[a].speed*time_elapsed*rot_factor);
		D3DXMatrixMultiply(&ball[a].rot,&ball[a].rot,&rot);

		Pocketing(a); // test pocketing if pocketing rotate dir and test if needs replaced

		if(!ball[a].pocketing) 
			ColCushons(a);  // ball not pocketing test against cushions 
		else 
			ColPocket(a);  // limit ball against pockets
		}
	}
	
	BOOL move[23]; // only want to move ball one full percentage per frame 
	for(a=0;a<23;a++) move[a]=FALSE;

	for(a=0;a<23;a++) // balls collisions 
	{
		for(int b=0;b<23;b++)
		{
			if(a!=b) 	// ignore same ball 
			{		
				float percent=BallsCollisions(a,b); // get where in path is collision 
				if(percent>0.0f)
				{
					move[a]=move[b]=TRUE;  // ball a,b has collided 
					
					MoveBall(a,percent); // move ball a upto collision with ball b 
					MoveBall(b,percent);

					PlayClick();
					CalcBallBounce(a,b);
		
					MoveBall(b,1.0f-percent);			
					MoveBall(a,1.0f-percent); // seperate balls ??? not yet do all pre move checks 
				}
			}
		}
	}

	for(a=0;a<23;a++)  // need changing for cushons 
	{
		if(!move[a])
			MoveBall(a,1);
	}
}
// end physics 

void SetupMatrices()
{
	if(rotY) RotY+=rotY*time_elapsed; // turn view around cue ball 
	if(eyeY){
		EyeY+=eyeY*time_elapsed;
		EyeY=max(minEyeY,EyeY);  // 1m from floor  ie level with table surface 
		EyeY=min(maxEyeY,EyeY); // 3m view over table 
	}

	eye=D3DXVECTOR3(viewDistFromCueBall*(float)sin(RotY),EyeY,viewDistFromCueBall*(float)cos(RotY)); // camera pos should be 1m away 
	at=ball[0].pos; // look at 
	eye.x+=at.x; eye.z+=at.z; // not y else lift higher 

	D3DXMatrixIdentity(&world);
	lpD3DDevice->SetTransform(D3DTS_WORLD,&world);

	D3DXMatrixLookAtLH(&view,&eye,&at,&D3DXVECTOR3(0.0f,1.0f,0.0f) ); 
    lpD3DDevice->SetTransform(D3DTS_VIEW,&view);

	D3DXMatrixPerspectiveFovLH(&proj,fov[hdtv],aspect[hdtv], 0.01f, 100.0f ); // 60 degree FOV, 1cm - 100m view 
    lpD3DDevice->SetTransform(D3DTS_PROJECTION,&proj);
}

void RenderBall(int b)
{
	if(GameType==21)
	{	
		ballType=1; // only uk option in snooker
		if(b<16 && b!=0) b=22; // reds from 0-15
	}

	if(GameType==9)
	{
		ballType=0; // only us option in 9ball 
	}

	if(GameType==15)
	{
		if(ballType==1 && b!=0) // not white 
		{
			if(b==8)b=16; // black
			else
			{
				if(b%2 && b!=15)b=22; else b=21;  // red even, yellow odd
			}
		}
	}

	for(DWORD i=0; i<ball[b].nBallMaterials; i++ ) // draw ball 
	{
		lpD3DDevice->SetMaterial(&ball[b].lpBallMaterials[i]); 
		lpD3DDevice->SetTexture(0,ball[b].lpBallTextures[i]);
		ball[b].lpBall->DrawSubset(i); 
	}
}

void RenderTable()
{
	for(DWORD i=0; i<lpTable[table].nMaterials; i++ )	// draw table   
	{
		lpD3DDevice->SetMaterial(&lpTable[table].lpMaterials[i]);     
		lpD3DDevice->SetTexture(0,lpTable[table].lpTextures[i]);
		if(tableCloth[table][i])lpD3DDevice->SetTexture(0,lpTableClothTextures[cloth]); // special
		lpTable[table].lpMesh->DrawSubset(i);	
	}
}

void RenderCue()
{
	for(DWORD i=0; i<lpCue[cue].nMaterials; i++ )
	{
		lpD3DDevice->SetMaterial(&lpCue[cue].lpMaterials[i]);    
		lpD3DDevice->SetTexture(0,lpCue[cue].lpTextures[i]);
		lpCue[cue].lpMesh->DrawSubset(i);
	}
}

HRESULT InvalidateDevObj()
{ 
	return S_OK; 
}

HRESULT RestoreDevObj()
{ 
	lpD3DDevice->SetRenderState(D3DRS_ZENABLE,TRUE); // z buffer 
	lpD3DDevice->SetTextureStageState(0,D3DTSS_MAGFILTER,D3DTEXF_LINEAR );
	lpD3DDevice->SetTextureStageState(0,D3DTSS_MINFILTER,D3DTEXF_LINEAR );
	lights(); // set lights and enable 	
	return S_OK; 
}

HRESULT Resize3D()
{
	HRESULT hr;
	if(FAILED(hr=InvalidateDevObj() )) return hr;
	if(FAILED(hr=lpD3DDevice->Reset(&d3dpp) )) return hr;
	if(FAILED(hr=RestoreDevObj() )) return hr;
	return S_OK;
}

HRESULT Render()
{
	time_elapsed=GetElapsed();
	
	GamePhysics(); // get time delay, do physics (AI), then render 

	HRESULT hr;
	if(FAILED(hr=lpD3DDevice->TestCooperativeLevel() )) //  ??? buggy 
	{
		if(D3DERR_DEVICELOST==hr) return S_OK;

		if(D3DERR_DEVICENOTRESET==hr)
		{
			if(FAILED(hr=Resize3D() )) return hr;
		}
		return hr;
	}

	lpD3DDevice->Clear(0,NULL,D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER,
		D3DCOLOR_XRGB(0,0,0),1.0f,0);

	if(changeViewport)
	{
		changeViewport=FALSE;
		if(hdtv==0) hdtv=1; else hdtv=0;
		lpD3DDevice->SetRenderState( D3DRS_AMBIENT, ambient[hdtv] );
	}
    
    if(SUCCEEDED(lpD3DDevice->BeginScene() ))
	{
		SetupMatrices();
		RenderTable();	

		for(DWORD i=0; i<nSceneMaterials; i++ )	// draw scene
		{
			lpD3DDevice->SetMaterial(&lpSceneMaterials[i]);     
			lpD3DDevice->SetTexture(0,lpSceneTextures[i]);
			lpScene->DrawSubset(i);	
		}

		D3DXMATRIX worldShadow,trans,lift;

		for(int b=0;b<23;b++) 	// render balls 0-22
		{
			if(ball[b].show) // ie is ball in play or pocketing 
			{			
				D3DXMatrixTranslation(&trans,ball[b].pos.x,ball[b].pos.y,ball[b].pos.z);
				D3DXMatrixMultiply(&world,&ball[b].rot,&trans);		// rotate THEN translate 	
				lpD3DDevice->SetTransform(D3DTS_WORLD,&world);
				RenderBall(b);			

				if(!ball[b].pocketing) // if not pocketing draw a shadow 
				{
					D3DXMatrixTranslation(&lift,ball[b].pos.x/50.0f,
											-ballRadius+0.002f, // 2mm off ground
											ball[b].pos.z/50.0f);
					D3DXMatrixMultiply(&worldShadow,&trans,&lift);
					
					for(i=0; i<nShadowMaterials; i++ )
					{
						lpD3DDevice->SetTransform(D3DTS_WORLD,&worldShadow);
						lpD3DDevice->SetMaterial(&lpShadowMaterials[i]);   
						lpD3DDevice->SetTexture(0,lpShadowTextures[i]);
						lpShadow->DrawSubset(i);
					}
				}
			}
			else // show potted balls in a row in ball collection area 
			{ // bug for bigger table 
				D3DXMatrixTranslation(&world,b*ballDiameter-0.6f,tableHeight-0.37f,0.6f); // show balls at side   
				lpD3DDevice->SetTransform(D3DTS_WORLD,&world);
				if(b<GameType+1) RenderBall(b); // hide balls not in game
			}	
		}

		if(ShowCue)
		{
			// calculate cue direction 
			D3DXVECTOR3 table=D3DXVECTOR3(-1.0f,0.0f,0.0f);
			D3DXVECTOR3 cue=eye-at; // cue direction vector 
			cue.y=0.0f; // make 2d 
			D3DXVec3Normalize(&nCue,&cue); // make unit length 
			nCue*=CueFromBall; // how far cue is from white ball centre
			float d=D3DXVec3Dot(&table,&cue); // DP between table and cue
			float ab=D3DXVec3Length(&table)*D3DXVec3Length(&cue);
			float ang=(float)acos(d/ab);  // get angle between x axis and ( eye to at ) to place cue 

			if(cue.z>0.0f) D3DXMatrixRotationYawPitchRoll(&world,(D3DX_PI/2)+ang,cueSlant,0.0f); 
			else D3DXMatrixRotationYawPitchRoll(&world,(D3DX_PI/2)-ang,cueSlant,0.0f);

			float lift=CueFromBall*(float)sin(cueSlant); // lift by slant use sin rule 		
			D3DXMatrixTranslation(&trans,ball[0].pos.x+nCue.x,tableHeight+ballRadius+lift,ball[0].pos.z+nCue.z);
		
			D3DXMatrixMultiply(&world,&world,&trans);
			
			lpD3DDevice->SetTransform(D3DTS_WORLD,&world);
			RenderCue();		
		}
		lpD3DDevice->EndScene();
	}
    lpD3DDevice->Present(NULL,NULL,NULL,NULL);
	return S_OK;
}

void UseInput(POINT Point)
{
	if(zoom)
	{
		rotY=eyeY=0.0f; // stop spin
		viewDistFromCueBall+=Point.y*time_elapsed; 
		viewDistFromCueBall=max(cueViewMin,viewDistFromCueBall); 
		viewDistFromCueBall=min(cueViewMax,viewDistFromCueBall); 
		return;
	}
	if(cueSlantAdjust)
	{
		rotY=eyeY=0.0f; // stop spin
		cueSlant+=Point.y*time_elapsed;
		cueSlant=max(cueSlant,0.1f); // min 5.7 degrees
		cueSlant=min(cueSlant,1.0f); // max 57 degrees
		return;
	}

	if(!shoot) // move view around cue ball 
	{
		rotY=(float)Point.x; // could be used to slow rotation or up/down *0.5f
		eyeY=(float)Point.y;
		CueFromBall=cueminfromball+(ballRadius); // move to cue to just away from ball
		CueSpeed=0.0f;  // cue = 0 m/s 
	}
	else // move cue 
	{	
		CueSpeed=(float)fabs((float)Point.y);
		rotY=eyeY=0.0f;
		CueFromBall+=(float)Point.y*time_elapsed;
		CueFromBall=max(ballRadius*0.8f,CueFromBall); // cue minimum distance touchs cueball surface  
		CueFromBall=min(cuemaxfromball+ballRadius,CueFromBall); // ie max is 30cm from ball 
	}
}
BOOL pause=FALSE;

LRESULT WINAPI WndProc( HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	static BOOL minimized,maximized,onehit;
    switch(msg)
    {
	case WM_LBUTTONDOWN:
		shoot=TRUE;
		return 0;
	case WM_LBUTTONUP:
		shoot=FALSE;
		return 0;

	case WM_KEYDOWN:
		switch(wParam){
		case 'A': cueSlantAdjust=TRUE; break;
		case 'S': shoot=TRUE; break;
		case 'Z': zoom=TRUE; break;
		case 'O': if(onehit){ coef_friction=0.7f; onehit=FALSE; } 
			else { coef_friction=-0.1f; onehit=TRUE; } break; // one hit wonder 
		case 'C': cloth++; if(cloth==6)cloth=0; break; 
		case 'Q': cue++; if(cue==nCues)cue=0; break; 
		case 'T': table++; if(table==nTables)table=0; LoadTableData(); 	ResetBalls(); break;
		case 'B': if(ballType) ballType=0; else ballType=1; break; // either us uk
		case 'G': if(gravup)gravup=FALSE; else gravup=TRUE; break; // gravity 
		case VK_F1: GameType=15; ResetBalls(); break;
		case VK_F2: GameType=9; ResetBalls(); break;
		case VK_F3: GameType=21; ResetBalls(); break;
		case 'W': if(wireframe){
					  lpD3DDevice->SetRenderState(D3DRS_FILLMODE,D3DFILL_SOLID);
					  wireframe=FALSE;		 }
				else {
					  lpD3DDevice->SetRenderState(D3DRS_FILLMODE,D3DFILL_WIREFRAME);
					  wireframe=TRUE;		}
				break;
		case 'F': if(fog)fog=FALSE; else fog=TRUE;
				lpD3DDevice->SetRenderState( D3DRS_FOGENABLE, fog ); 
				break;
		case 'H': if(specular)specular=FALSE; else specular=TRUE;
				lpD3DDevice->SetRenderState( D3DRS_SPECULARENABLE, specular);
				break;
		case 'V': changeViewport=TRUE;
			break;
		case VK_ESCAPE: SendMessage(hwnd,WM_CLOSE,0,0); break;
		}
		return 0;
	case WM_KEYUP:
		switch(wParam){
		case 'A': cueSlantAdjust=FALSE; break;
		case 'S': shoot=FALSE; break;
		case 'Z': zoom=FALSE; break;
		}
		return 0;

	case WM_SYSCOMMAND:
        switch(wParam)
		{
			case SC_MOVE:
			case SC_SIZE:
			case SC_MAXIMIZE:
			case SC_KEYMENU:
			case SC_MONITORPOWER:
				return 1; 
		}
        break;
	case WM_ACTIVATEAPP:
		pause=(BOOL)wParam;
		return 0;	

	case WM_SIZE:
		if(SIZE_MAXHIDE==wParam || SIZE_MINIMIZED==wParam || SIZE_MAXSHOW==wParam)
			active=FALSE;
		else
			active=TRUE;
		return 0;

	case WM_CLOSE:
		SaveRegSettings( (DWORD)uAdapter,(DWORD)uMode,(DWORD)GameType,(DWORD)Windowed,(DWORD)table );
		Cleanup();
		DestroyWindow(hwnd);
		return 0;

	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;

	case WM_SETCURSOR:
		SetCursor(NULL); 
		return TRUE;
		
    }
    return DefWindowProc( hwnd, msg, wParam, lParam );
}

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE,LPSTR,int)
{
	g_hInst=hInst; 

	if(FAILED(Enum() )){ SafeRelease(lpD3D); return 0; } // D3D object, enumerate graphic devices,modes

	DialogBox(hInst,MAKEINTRESOURCE(IDDLG),NULL,StartupDlgProc); // get options 
	if(quit){ SafeRelease(lpD3D); return 0; } // quit if quit option chosen

	if(FAILED(InitLoadDMusic() )) 
		MessageBox(NULL,"Sound unavalible","DirectMusic",MB_OK|MB_ICONWARNING); 

  	WNDCLASS wc={0,WndProc,0,0,hInst,LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON1)),
		NULL,NULL,NULL,"Pool"};
	RegisterClass(&wc);   // no mouse needed

	int w=GetSystemMetrics(SM_CXFULLSCREEN); // fullscreen Primary monitor
	int h=GetSystemMetrics(SM_CYFULLSCREEN);	
	w=w/10; h=h/10; 

	QPFTimer(); 

	HWND hwnd;

	if(Windowed)
		hwnd=CreateWindowEx(0,"Pool","3D Pool",
		WS_OVERLAPPEDWINDOW|WS_VISIBLE,w,h,w*8,h*8,NULL,NULL,hInst,NULL); // make windowed screen fit 
	else
		hwnd=CreateWindowEx(WS_EX_TOPMOST,"Pool","3D Pool",
		WS_OVERLAPPEDWINDOW|WS_VISIBLE,0,0,0,0,NULL,NULL,hInst,NULL); // make windowed screen fit 

/*	if(Windowed)
	{
		GetWindowRect(hwnd,&rect);
		ClipCursor(&rect);
	}
*/
	if(FAILED(InitDInput(hInst,hwnd) ))
	{
		MessageBox(NULL,"Direct Input","Error",MB_OK);
		SendMessage(hwnd,WM_CLOSE,0,0);
	}

	if(FAILED(InitD3D(hwnd)	))
	{
		MessageBox(NULL,"Direct3D","Error",MB_OK);
		SendMessage(hwnd,WM_CLOSE,0,0);
	}
	else
	{
		Timer(TIMER_START);
		ready=TRUE;
	}

	ResetBalls(); 
	

	MSG msg; 
	BOOL GotMsg;
	PeekMessage(&msg,NULL,0U,0U,PM_NOREMOVE);            
    while(msg.message!=WM_QUIT )
    {
    	if(active)
		GotMsg=PeekMessage(&msg,NULL,0U,0U,PM_REMOVE);
		else
		GotMsg=PeekMessage(&msg,NULL,0U,0U,0U);
		if(GotMsg)
        {
			TranslateMessage( &msg );
            DispatchMessage( &msg );
        }
        else
		{
            if(active && ready && pause)
			{	
				POINT p=ProcessInput();
				UseInput(p);
				Render();  
			}
		}
    }        
    return msg.wParam;
}